fn print_bytes(bytes:&Vec<u8>)
{
    for b in bytes {
        print!("{:02x} ", *b);
    } print!("\n");
}

fn main() {
    let a = szun::Decimal::with(32, 128.5);
    let b = szun::Decimal::with(24, 16.0);
    let c = a.copy() / b.copy();

    println!("A      =  {} (.{})", a.get(), a.mantissa());
    println!("B      =  {} (.{})", b.get(), b.mantissa());
    print!("\n");
    println!("A + B  =  {}", (a.copy() + b.copy()).get());
    println!("A - B  =  {}", (a.copy() - b.copy()).get());
    println!("A * B  =  {}", (a.copy() * b.copy()).get());
    println!("A / B  =  {}", (a.copy() / b.copy()).get());
    println!("A % B  =  {}", (a.copy() % b.copy()).get());
    print!("\n");
    println!("B + A  =  {}", (b.copy() + a.copy()).get());
    println!("B - A  =  {}", (b.copy() - a.copy()).get());
    println!("B * A  =  {}", (b.copy() * a.copy()).get());
    println!("B / A  =  {}", (b.copy() / a.copy()).get());
    println!("B % A  =  {}", (b.copy() % a.copy()).get());

    print!("\n");
    let out = szun::encode(*c);
    println!("c = {}", c.get());
    print_bytes(&out);
    match szun::decode(&out, &mut 0) {
        Ok(ty) => match ty {
            szun::Type::Decimal(val) => {
                println!("decode = {}", val.get());
            }
            _ => { println!("other"); }
        }
        Err(_) => { println!("failed"); }
    }
}
